<?php
/***********************************************************************************
*
* @author Daniel Chalsche (Dakin Quelia) http://www.danielchalseche.be/
*
* @package Game
* @version $Id: functions_news.php
* @copyright (c) 2010 Daniel Chalsche
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
***********************************************************************************/

/**
* @ignore
*/
if (!defined('IN_SITE'))
{
	exit;
}

class news
{
	// Variables Gnrales
	var $news; 
	var $archives;
	
	/******************************************************************
	* @function 	- Display News
	* @version 		- 1.0.0
	* @author		- Dakin Quelia
	* @description  - 
	*				  Cette fonction a pour simple but d'afficher les
	*				  nouvelles du site mais aux caractres limits.
	******************************************************************/ 
	function display_news()
	{
		global $db, $auth, $config, $phpEx, $user, $template, $phpbb_root_path;
		global $new;
		
		$start 		= request_var('start', 0);
		$new 		= request_var('id', 0);
		$forum_news = 'ID forum des nouvelles'; 
		
		$config['posts_per_page'] = 5;
		$config['news_char_limit'] = 300;
				
		// Go ahead and pull all data for news
		$sql_ary = array (
			'SELECT'	=> 'p.post_id, p.post_username, p.post_subject, p.post_text, t.topic_id, t.topic_views, t.topic_title, t.topic_time, p.enable_bbcode, p.enable_magic_url, p.enable_smilies, p.bbcode_uid, p.bbcode_bitfield, u.*',
			'FROM'		=> array(
				POSTS_TABLE		=> 'p',
				TOPICS_TABLE	=> 't',
			),
			'LEFT_JOIN'	=> array(
				array(
					'FROM'	=> array(USERS_TABLE => 'u'),
					'ON'	=> 'p.poster_id = u.user_id'
				),
			),
			'WHERE'		=> 't.forum_id =' . $forum_news . ' AND t.topic_title = p.post_subject',
			'ORDER_BY'  => 'topic_time DESC',
		);  
	
		$sql = $db->sql_build_query('SELECT', $sql_ary);
		$result = $db->sql_query_limit($sql, $config['posts_per_page'], $start);
		
		while ($news = $db->sql_fetchrow($result))
		{
			$news['bbcode_options'] = (($news['enable_bbcode']) ? OPTION_FLAG_BBCODE : 0) + (($news['enable_smilies']) ? OPTION_FLAG_SMILIES : 0) + (($news['enable_magic_url']) ? OPTION_FLAG_LINKS : 0);
			$news_id = $news['topic_id'];
			
			$template->assign_block_vars('news', array(
				'NEW_AUTHOR'	=> get_username_string('full', $news['user_id'], $news['username'], $news['user_colour']),
				'NEW_TITLE'		=> $news['topic_title'],
				'NEW_TIME'		=> $user->format_date($news['topic_time'], 'd/m/y'),
				'NEW_TEXT'		=> ((utf8_strlen($news['post_text']) > $config['news_char_limit'] + 50)) ? (utf8_substr($news['post_text'], 0, $config['news_char_limit']) . '...') : generate_text_for_display($news['post_text'], $news['bbcode_uid'], $news['bbcode_bitfield'], $news['bbcode_options']),
				'NEW_VIEWS'		=> sprintf($user->lang['NEWS_VIEW'], $news['topic_views']),
				'NEW_READ'		=> sprintf($user->lang['NEWS_READ'], '<a href="' . append_sid("{$phpbb_root_path}news.$phpEx", "id=$news_id") . '">', '</a>')
			));
		}
	
		// Navlinks
		$template->assign_block_vars('navlinks', array(
			'FORUM_NAME'	=> $news['topic_title'],
			'U_VIEW_FORUM'	=> append_sid("{$directory_root_path}news.$phpEx", array('id' => $news['topic_id']))
		));
	
		$body = 'mods/news/news_body.html';
	
		$template->set_filenames(array('body' => $body));
		
	}
	/******************************************************************
	* @function 	- Archives News
	* @version 		- 1.0.0
	* @author		- Dakin Quelia
	* @description  - 
	*				  Cette fonction a pour simple but d'afficher les
	*				  archives des nouvelles du site.
	******************************************************************/ 
	function archives_news()
	{
		// En cours
	}
	/******************************************************************
	* @function 	- View New
	* @version 		- 1.0.0
	* @author		- Dakin Quelia
	* @description  - 
	*				  Cette fonction a pour simple but d'afficher la
	*				  nouvelle entire sans censure.
	******************************************************************/ 
	function view_new($id)
	{
		global $db, $auth, $config, $phpEx, $user, $template, $phpbb_root_path;
		global $new, $forum_news;
		
		$start 		= request_var('start', 0);
		$new 		= request_var('id', 0);
		
		$config['posts_per_page'] = 5;

		// Go ahead and pull all data for documents
		$sql_ary = array(
			'SELECT'	=> 'p.post_id, p.forum_id, p.post_username, p.post_subject, p.post_text, t.topic_views, t.topic_title, t.topic_time, p.enable_bbcode, p.enable_magic_url, p.enable_smilies, p.bbcode_uid, p.bbcode_bitfield, u.*',
			'FROM'		=> array(
				POSTS_TABLE		=> 'p',
				TOPICS_TABLE	=> 't',
			),
			'LEFT_JOIN'	=> array(
				array(
					'FROM'	=> array(USERS_TABLE => 'u'),
					'ON'	=> 'p.poster_id = u.user_id'
				),
			),
			'WHERE'		=> 't.topic_id = ' . $new . ' AND t.topic_id = p.topic_id',
			'ORDER_BY'  => 'p.post_time ASC'
		); 
		$sql = $db->sql_build_query('SELECT', $sql_ary);
		$result = $db->sql_query_limit($sql, $config['posts_per_page'], $start);
		$news = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);
	
		$news['bbcode_options'] = (($news['enable_bbcode']) ? OPTION_FLAG_BBCODE : 0) + (($news['enable_smilies']) ? OPTION_FLAG_SMILIES : 0) + (($news['enable_magic_url']) ? OPTION_FLAG_LINKS : 0);
			
		$template->assign_vars(array(
			'NEW_ID'		=> $news['post_id'],
			'NEW_AUTHOR'	=> get_username_string('full', $news['user_id'], $news['username'], $news['user_colour']),
			'NEW_TITLE'		=> $news['post_subject'],
			'NEW_TIME'		=> $user->format_date($news['topic_time'], 'd/m/y'),
			'NEW_TEXT'		=> generate_text_for_display($news['post_text'], $news['bbcode_uid'], $news['bbcode_bitfield'], $news['bbcode_options']),
			'NEW_VIEWS'		=> sprintf($user->lang['NEWS_VIEW'], $news['topic_views']),
			)
		);
		
		
		// Update topic view and if necessary attachment view counters ... but only for humans and if this is the first 'page view'
		if (isset($user->data['session_page']) && !$user->data['is_bot'] && (strpos($user->data['session_page'], '&t=' . $topic_id) === false || isset($user->data['session_created'])))
		{
			$sql = 'UPDATE ' . TOPICS_TABLE . '
					SET topic_views = topic_views + 1, topic_last_view_time = ' . time() . "
					WHERE topic_id = $new";
			$db->sql_query($sql);
		}
		
		// Obtain correct post count
		$sql_ary['SELECT'] = 'COUNT(p.post_id) as num_posts';
		$sql = $db->sql_build_query('SELECT', $sql_ary);
		$result = $db->sql_query($sql);
		$total_posts = (int) $db->sql_fetchfield('num_posts');
		$db->sql_freeresult($result);
		
		// What is start equal to?
		if ($start < 0 || $start >= $total_posts)
		{
			$start = ($start < 0) ? 0 : floor(($total_posts - 1) / $config['posts_per_page']) * $config['posts_per_page'];
		}
	
		// If we've got a hightlight set pass it on to pagination.
		$pagination = generate_pagination(append_sid("{$phpbb_root_path}docs.$phpEx", "cat=" . $cat . "&amp;viewdoc=" . $doc), $total_posts, $config['posts_per_page'], $start);
	
		// Send vars to template
		$template->assign_vars(array(
			'DOC_VIEWS'				=> sprintf($user->lang['VIEW_DOCS'], $docs_views),
			
			'PAGINATION' 			=> $pagination,
			'PAGE_NUMBER' 			=> on_page($total_posts, $config['posts_per_page'], $start),
			'TOTAL_POSTS'			=> ($total_posts == 1) ? $user->lang['NB_POST'] : sprintf($user->lang['NB_POSTS'], $total_posts),
			)
		);	
		
		$body = 'mods/news/news_viewnew.html';
	
		$template->set_filenames(array('body' => $body));
	}
}

?>